Attribute VB_Name = "modMeetingRoom"
Option Explicit

Public meetingRoomList() As Variant

Public Sub MeetingSchedulerForm()
    frmMeetingRoom.Show
End Sub

Sub GetMeetingRoomList()
    Dim outApp As Object, outNS As Outlook.NameSpace
    Dim addrEntry As Outlook.AddressEntry
    Dim myAddressList As Outlook.AddressList
    Dim iCount As Integer
    Erase meetingRoomList
    Set outApp = CreateObject("Outlook.Application")
    Set outNS = outApp.GetNamespace("MAPI")
    Set myAddressList = outNS.Session.AddressLists("Global Address List")
    iCount = 0
    For Each addrEntry In myAddressList.AddressEntries
        If InStr(1, addrEntry.Name, "CR - Ropemaker") > 0 Then
            ReDim Preserve meetingRoomList(iCount)
            meetingRoomList(iCount) = addrEntry.Name
            iCount = iCount + 1
        End If
    Next addrEntry
    Set outApp = Nothing
End Sub

Function FindFreeTime(dtmAppt As Date, strEmp() As Variant, C_intDefaultAppt As Integer) As String
     '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     ' Purpose:      Capture all available timeslots (between appointments) on
     '               nominated day
     '
     ' Inputs:       dtmAppt         Date to search
     '               strEmp          Array containing all employee calendars to
     '                                   search
     '
     ' Assumptions:  * User must have access to the appropriate shared calendars in
     '                 Outlook
     '               * Free timeslot must be >= default appointment time
     '               * Free timeslot must be between default start and end times for
     '                 appointments
     '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     'Code Resource Link: http://www.vbaexpress.com/kb/getarticle.php?kb_id=671
     
    Dim objOL As New Outlook.Application ' Outlook
    Dim objNS As NameSpace ' Namespace
    Dim OLFldr As Outlook.MAPIFolder ' Calendar folder
    Dim OLAppt As Object ' Single appointment
    Dim OLRecip As Outlook.Recipient ' Outlook user name
    Dim OLAppts As Outlook.Items ' Appointment collection
    Dim strDay As String ' Day for appointment
    Dim strList As String ' List of all available timeslots
    Dim dtmNext As Date ' Next available time
    Dim intDuration As Integer ' Duration of free timeslot
    Dim i As Integer ' Counter
     
    Const C_Procedure = "FindFreeTime" ' Procedure name
    Const C_dtmFirstAppt = #8:00:00 AM# ' First appointment time
    Const C_dtmLastAppt = #7:00:00 PM# ' Last appointment time
    'Const C_intDefaultAppt = 30 '120 ' Default appointment duration
     
     
    On Error GoTo ErrHandler
     
     ' list box column headings
    strList = "Meeting Room;Start Time;End Time;"
     
     ' get full span of selected day
    strDay = "[Start] >= '" & FormatDateTime(dtmAppt, vbShortDate) & "' and " & _
    "[Start] < '" & FormatDateTime(dtmAppt, vbShortDate) & " 11:59 pm'"
     
     ' loop through shared Calendar for all Employees in array
    Set objNS = objOL.GetNamespace("MAPI")
     
    For i = 0 To UBound(strEmp)
        frmMeetingRoom.Label3.Caption = "Processing room: " & strEmp(i)
        DoEvents
        On Error GoTo ErrHandler
        Set OLRecip = objNS.CreateRecipient(strEmp(i))
         
        On Error Resume Next
        Set OLFldr = objNS.GetSharedDefaultFolder(OLRecip, olFolderCalendar)
         
         ' calendar not shared
        If Err.Number <> 0 Then
            strList = strList & strEmp(i) & _
            ";Calendar not shared;Calendar not shared;"
             
            GoTo NextEmp
        End If
         
        On Error GoTo ErrHandler
        Set OLAppts = OLFldr.Items
         
        dtmNext = C_dtmFirstAppt
         
         ' Sort the collection (required by IncludeRecurrences)
        OLAppts.Sort "[Start]"
         
         ' Make sure recurring appointments are included
        OLAppts.IncludeRecurrences = True
         
         ' Filter the collection to include only the day's appointments
        Set OLAppts = OLAppts.Restrict(strDay)
         
         ' Sort it again to put recurring appointments in correct order
        OLAppts.Sort "[Start]"
         
        With OLAppts
             ' capture subject, start time and duration of each item
            Set OLAppt = .GetFirst
             
            Do While TypeName(OLAppt) <> "Nothing"
                 ' find first free timeslot
                Select Case DateValue(dtmAppt)
                Case DateValue(Format(OLAppt.Start, "dd/mm/yyyy"))
                    If Format(dtmNext, "Hh:Nn") < _
                    Format(OLAppt.Start, "Hh:Nn") Then
                         
                         ' find gap before next appointment starts
                        If Format(OLAppt.Start, "Hh:Nn") < _
                        Format(C_dtmLastAppt, "Hh:Nn") Then
                            intDuration = DateDiff("n", dtmNext, _
                            Format(OLAppt.Start, "Hh:Nn"))
                        Else
                            intDuration = DateDiff("n", dtmNext, _
                            Format(C_dtmLastAppt, "Hh:Nn"))
                        End If
                         
                         ' can we fit an appointment into the gap?
                        If intDuration >= C_intDefaultAppt Then
                            strList = strList & strEmp(i) & _
                            ";" & Format(dtmNext, "Hh:Nn ampm") & _
                            ";" & Format(DateAdd("n", intDuration, _
                            dtmNext), "Hh:Nn ampm") & ";"
                        End If
                    End If
                     
                     ' find first available time after appointment
                    dtmNext = DateAdd("n", OLAppt.Duration + intDuration, _
                    dtmNext)
                     
                     ' don't go beyond last possible appointment time
                    If dtmNext > C_dtmLastAppt Then
                        Exit Do
                    End If
                End Select
                 
                intDuration = 0
                 
                Set OLAppt = .GetNext
            Loop
        End With
         
         ' capture remainder of day
        intDuration = DateDiff("n", dtmNext, Format(C_dtmLastAppt, "Hh:Nn"))
         
        If intDuration >= C_intDefaultAppt Then
            strList = strList & strEmp(i) & _
            ";" & Format(dtmNext, "Hh:Nn ampm") & _
            ";" & Format(DateAdd("n", intDuration, dtmNext), "Hh:Nn ampm") & _
            ";"
        End If
         
NextEmp:
         ' add note for unavailable Employee
        If InStr(1, strList, strEmp(i)) = 0 Then
            strList = strList & strEmp(i) & _
            ";Unavailable this day;Unavailable this day;"
        End If
    Next i
     
    FindFreeTime = strList
     
     
ExitHere:
    On Error Resume Next
    Set OLAppt = Nothing
    Set OLAppts = Nothing
    Set objNS = Nothing
    Set objOL = Nothing
     
    Exit Function
     
ErrHandler:
    MsgBox Err.Number & ": " & C_Procedure & vbCrLf & Err.Description
    Resume ExitHere
End Function
 
